/* quine library data */

const char *qq_qqlib[] = {
"/* -*-c-*-%n",
" *%n",
" * $Id: qqlib.c,v 1.1.1.1 1999/04/28 19:58:07 mdw Exp $%n",
" *%n",
" * Useful library of tools for quines%n",
" *%n",
" * (c) 1999 Mark Wooding%n",
" */%n",
"%n",
"/*----- Licensing notice --------------------------------------------------*%n",
" *%n",
" * This file is part of Quine%n",
" *%n",
" * Quine is free software; you can redistribute it and/or modify%n",
" * it under the terms of the GNU General Public License as published by%n",
" * the Free Software Foundation; either version 2 of the License, or%n",
" * (at your option) any later version.%n",
" *%n",
" * Quine is distributed in the hope that it will be useful,%n",
" * but WITHOUT ANY WARRANTY; without even the implied warranty of%n",
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the%n",
" * GNU General Public License for more details.%n",
" *%n",
" * You should have received a copy of the GNU General Public License%n",
" * along with Quine; if not, write to the Free Software Foundation,%n",
" * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.%n",
" *%n",
" * However, when this source text is embedded in a file by the Quine%n",
" * program, you may do anything you like with the resulting text;%n",
" * distribution and modification are not limited by the General Public%n",
" * License.%n",
" */%n",
"%n",
"/*----- Revision history --------------------------------------------------*%n",
" *%n",
" * $Log: qqlib.c,v $%n",
" * Revision 1.1.1.1  1999/04/28 19:58:07  mdw%n",
" * Initial revision%n",
" *%n",
" */%n",
"%n",
"/*----- Header files ------------------------------------------------------*/%n",
"%n",
"/* --- ANSI headers --- */%n",
"%n",
"#include <ctype.h>%n",
"#include <errno.h>%n",
"#include <stdio.h>%n",
"#include <stdlib.h>%n",
"#include <string.h>%n",
"%n",
"/* --- POSIX headers --- */%n",
"%n",
"#ifndef QUINE_PORTABLE%n",
"#  include <sys/types.h>%n",
"#  include <sys/fcntl.h>%n",
"#  include <sys/stat.h>%n",
"#  include <unistd.h>%n",
"#endif%n",
"%n",
"/* --- Local headers --- */%n",
"%n",
"#include %qquine.h%q%n",
"%n",
"/*----- Macro hacking -----------------------------------------------------*/%n",
"%n",
"#ifdef QUINE_PORTABLE%n",
"#  define PORT(x) x%n",
"#  define NPORT(x)%n",
"#else%n",
"#  define PORT(x)%n",
"#  define NPORT(x) x%n",
"#endif%n",
"%n",
"/*----- Main code ---------------------------------------------------------*/%n",
"%n",
"/* --- @qq_xlate@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = output file handle%n",
" *%t%t@const char *p@ = pointer to encoded text%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tWrites the decoded string to the given file handle.%n",
" */%n",
"%n",
"void qq_xlate(FILE *fp, const char *p)%n",
"{%n",
"  while (*p) {%n",
"    if (*p == '%%') {%n",
"      p++;%n",
"      switch (*p) {%n",
"%tcase 'q': fputc('%b%q', fp); break;%n",
"%tcase 'b': fputc('%b%b', fp); break;%n",
"%tcase 't': fputc('%bt', fp); break;%n",
"%tcase 'n': fputc('%bn', fp); break;%n",
"%tcase 'a': fputc('%ba', fp); break;%n",
"%tcase 'r': fputc('%br', fp); break;%n",
"%tcase '0': fputc('%b0', fp); break;%n",
"%tcase '%%': fputc('%%', fp);  break;%n",
"%tcase 'x': {%n",
"%t  unsigned char ch = 0;%n",
"%t  p++;%n",
"%t  while (*p != '%%') {%n",
"%t    unsigned int x = *p++;%n",
"%t    x -= '0';%n",
"%t    if (x >= 10) x -= 'a' - '0' - 10;%n",
"%t    if (x >= 16) x -= 'A' - 'a';%n",
"%t    ch = (ch << 4) + x;%n",
"%t  }%n",
"%t  fputc(ch, fp);%n",
"%t} break;%n",
"%tdefault:%n",
"%t  p--;%n",
"%t  break;%n",
"      }%n",
"    } else%n",
"      fputc(*p, fp);%n",
"    p++;%n",
"  }%n",
"}%n",
"%n",
"/* --- @qq_file@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = output file handle%n",
" *%t%t@const char **p@ = pointer to the output array%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tWrites the contents of a file to the output.%n",
" */%n",
"%n",
"void qq_file(FILE *fp, const char **p)%n",
"{%n",
"  while (*p)%n",
"    qq_xlate(fp, *p++);%n",
"}%n",
"%n",
"/* --- @qq_head@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = output file handle%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tWrites the head of a `qqout.c' file.%n",
" */%n",
"%n",
"void qq_head(FILE *fp)%n",
"{%n",
"  fputs(%q/* quine output file */%bn%bn%q, fp);%n",
"}%n",
"%n",
"/* --- @qq_body@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = output file handle%n",
" *%t%t@const char ***p@ = pointer to main table%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tWrites the body table of a `qqout.c' file.%n",
" */%n",
"%n",
"void qq_body(FILE *fp, const char ***p)%n",
"{%n",
"  size_t fno = 0;%n",
"  const char **q;%n",
"%n",
"  fputs(%q/* --- file contents tables --- */%bn%bn%q, fp);%n",
"  while (*p) {%n",
"    q = *p;%n",
"    fprintf(fp, %qstatic const char *qq__c_%%lx[] = {%bn%q, (unsigned long)fno);%n",
"    fprintf(fp, %q/* Filename: */ %b%q%%s%b%q,%bn%q, *q++);%n",
"    if (strncmp(*q, %q%%!%q, 2) == 0)%n",
"      fprintf(fp, %q/* Mode: */ %b%q%%s%b%q,%bn%q, *q++);%n",
"    while (*q)%n",
"      fprintf(fp, %q%b%q%%s%b%q,%bn%q, *q++);%n",
"    fputs(%q0%bn};%bn%bn%q, fp);%n",
"    p++;%n",
"    fno++;%n",
"  }%n",
"}%n",
"    %n",
"/* --- @qq_tail@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = output file handle%n",
" *%t%t@const char **qql@ = pointer to qqlib file array%n",
" *%t%t@size_t fno@ = number of files written%n",
" *%t%t@const char *fn@ = name of `qqout.c' file%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tWrites the head of a `qqout.c' file.%n",
" */%n",
"%n",
"void qq_tail(FILE *fp, const char **qql, size_t fno, const char *fn)%n",
"{%n",
"  const char **p;%n",
"  size_t i;%n",
"%n",
"  /* --- Write out the qqlib array --- */%n",
"%n",
"  fputs(%q/* --- qqlib code --- */%bn%bn%q%n",
"%t%qconst char *qq_qqlib[] = {%bn%q, fp);%n",
"  for (p = qql; *p; p++)%n",
"    fprintf(fp, %q%b%q%%s%b%q,%bn%q, *p);%n",
"  fputs(%q0%bn};%bn%bn%q, fp);%n",
"%n",
"  /* --- Build the main array --- */%n",
"%n",
"  fputs(%q/* --- table of files to output --- */%bn%bn%q%n",
"%t%qconst char **qq_table[] = {%bn%q, fp);%n",
"  for (i = 0; i < fno; i++)%n",
"    fprintf(fp, %q  qq__c_%%lx,%bn%q, (unsigned long)i);%n",
"  fputs(%q  0%bn};%bn%bn%q, fp);%n",
"%n",
"  /* --- Now output the qqlib code --- */%n",
"%n",
"  fputs(%q#define QQ_OUT%bn%bn%q, fp);%n",
"  qq_file(fp, qql);%n",
"%n",
"  /* --- Finally write the code to write everything out --- */%n",
"%n",
"  fprintf(fp,%n",
"%t  %q/* --- quine output routines --- */%bn%bn%q%n",
"%t  %qvoid qq_dump(FILE *fp) {%bn%q%n",
"%t  %q  qq__dump(fp, qq_table, qq_qqlib, %b%q%%s%b%q, %%lu);%bn%q%n",
"%t  %q}%bn%q%n",
"%t  %qint qq_create(void) {%bn%q%n",
"%t  %q  return (qq__create(qq_table, qq_qqlib, %b%q%%s%b%q, %%lu));%bn%q%n",
"%t  %q}%bn%bn%q,%n",
"%t  fn, (unsigned long)fno, fn, (unsigned long)fno);%n",
"}%n",
"%n",
"/* --- @qq_mkfile@ --- *%n",
" *%n",
" * Arguments:%t@const char *fn@ = pointer to a filename%n",
" *%t%t@int mode@ = file mode to use (only in Unix-specific version)%n",
" *%n",
" * Returns:%tA handle for the created file.%n",
" *%n",
" * Use:%t%tCreates a file, and leading directories and stuff.%n",
" */%n",
"%n",
"#ifdef QUINE_PORTABLE%n",
"FILE *qq_mkfile(const char *fn)%n",
"{%n",
"  return (fopen(fn, %qw%q));%n",
"}%n",
"#else%n",
"FILE *qq_mkfile(const char *fn, int mode)%n",
"{%n",
"  char buf[FILENAME_MAX];%n",
"  char *p;%n",
"  int fd;%n",
"%n",
"  strcpy(buf, fn);%n",
"  p = strchr(buf, '/');%n",
"  for (;;) {%n",
"    if (!p)%n",
"      break;%n",
"    *p = 0;%n",
"    mkdir(buf, 0777);%n",
"    *p = '/';%n",
"    p = strchr(p + 1, '/');%n",
"  }%n",
"%n",
"  fd = open(fn, O_WRONLY|O_CREAT|O_TRUNC, mode);%n",
"  return (fd >=0 ? fdopen(fd, %qw%q) : 0);%n",
"}%n",
"#endif%n",
"%n",
"#ifdef QQ_OUT%n",
"%n",
"/* --- @qq__dump@ --- *%n",
" *%n",
" * Arguments:%t@FILE *fp@ = file to dump on%n",
" *%t%t@const char ***p@ = pointer to main table%n",
" *%t%t@const char **qql@ = pointer to qqlib code%n",
" *%t%t@const char *fn@ = name of `qqout.c' file%n",
" *%t%t@size_t fno@ = number of files to be output%n",
" *%n",
" * Returns:%t---%n",
" *%n",
" * Use:%t%tOutputs the entire source code to a given file.%n",
" */%n",
"%n",
"static void qq__dump(FILE *fp, const char ***p, const char **qql,%n",
"%t%t     const char *fn, size_t fno)%n",
"{%n",
"  const char ***q = p;%n",
"%n",
"  while (*q) {%n",
"    fprintf(fp, %q******** %%s%bn%bn%q, **q);%n",
"    qq_file(fp, *q + 1);%n",
"    q++;%n",
"  }%n",
"  fprintf(fp, %q******** %%s%bn%bn%q, fn);%n",
"  qq_head(fp);%n",
"  qq_body(fp, p);%n",
"  qq_tail(fp, qql, fno, fn);%n",
"}%n",
"%n",
"/* --- @qq__create@ --- *%n",
" *%n",
" * Arguments:%t@const char ***p@ = pointer to main table%n",
" *%t%t@const char **qql@ = pointer to qqlib code%n",
" *%t%t@const char *fn@ = name of `qqout.c' file%n",
" *%t%t@size_t fno@ = number of files to be output%n",
" *%n",
" * Returns:%tZero if all went well, else nonzero.%n",
" *%n",
" * Use:%t%tRebuilds the original source distribution.%n",
" */%n",
"%n",
"static int qq__create(const char ***p, const char **qql,%n",
"%t%t      const char *fn, size_t fno)%n",
"{%n",
"  FILE *fp;%n",
"  const char ***q = p;%n",
"  %n",
"  while (*q) {%n",
"    const char **qq = *q + 1;%n",
"%n",
"#ifdef QUINE_PORTABLE%n",
"    if (strncmp(*qq, %q%%!%q, 2) == 0)%n",
"      qq++;%n",
"    fp = qq_mkfile(*qq);%n",
"#else%n",
"    if (strncmp(*qq, %q%%!%q, 2) == 0) {%n",
"      fp = qq_mkfile(**q, (int)strtol(*qq + 2, 0, 8));%n",
"      qq++;%n",
"    } else%n",
"      fp = qq_mkfile(**q, 0666);%n",
"#endif%n",
"      %n",
"    if (!fp)%n",
"      return (-1);%n",
"    qq_file(fp, qq);%n",
"    if (fclose(fp))%n",
"      return (-1);%n",
"    q++;%n",
"  }%n",
"  fp = qq_mkfile(fn, 0666);%n",
"  if (!fp)%n",
"    return (-1);%n",
"  qq_head(fp);%n",
"  qq_body(fp, p);%n",
"  qq_tail(fp, qql, fno, fn);%n",
"  if (fclose(fp))%n",
"    return (-1);%n",
"  return (0);%n",
"}%n",
"%n",
"#endif%n",
"%n",
"/*----- That's all, folks -------------------------------------------------*/%n",
0
};

